
local buts;
local iconSize = 32;
local fishingSkill = 0;
local myFishingRod;
local prof;
local profTex1, profTex2;

local cooking;
local cookingTex;
local cookingDE = "Kochkunst";
local cookingEN = "Cooking";

local fishing;
local fishingTex;
local fishingDE = "Angeln";
local fishingEN = "Fishing";

local localCode;

local fische = { 
	{ "Winterlachs"                 ; "Glacial Salmon"        ; "Interface\\Icons\\INV_Misc_Fish_51"} ; 
	{ "Muschelr\195\188ckengroppe"  ; "Musselback Sculpin"    ; "Interface\\Icons\\INV_Misc_Fish_62" } ;
	{ "Nesselfisch"                 ; "Nettlefish"            ; "Interface\\Icons\\INV_Misc_Fish_72" } ; 

------------------------- all you can fish...to be completed

	{ "Roher T\195\188pfelgelbschwanz"; "Raw Spotted Yellowtail" ; "Interface\\Icons\\INV_Misc_Fish_01" } ;
	{ "Roher Steinschuppenkabeljau"; "Raw Rockscale Cod" ; "Interface\\Icons\\INV_Misc_Fish_02"} ;

	{ "Knochenschuppenschnapper"    ; "Bonescale Snapper"     ; "Interface\\Icons\\INV_Misc_Fish_48" } ;
	{ "Boreanische Galeere"         ; "Borean Man O' War"     ; "Interface\\Icons\\INV_Misc_Fish_49" } ;
	{ "Winterlachs"                 ; "Glacial Salmon"        ; "Interface\\Icons\\INV_Misc_Fish_51" } ; 
	{ "Engelsdrachenfisch"          ; "Dragonfin Angelfish"   ; "Interface\\Icons\\INV_Misc_Fish_54" } ;
	{ "Pygm\195\164enschiffshalter" ; "Pygmy Suckerfish"      ; "Interface\\Icons\\INV_Misc_Fish_55" } ;
	{ "Imperialer Mantarochen"      ; "Imperial Manta Ray"    ; "Interface\\Icons\\INV_Misc_Fish_59" } ;
	{ "Tiefseemonsterbauch"         ; "Deep Sea Monsterbelle" ; "Interface\\Icons\\INV_Misc_Fish_60" } ; 
	{ "Muschelr\195\188ckengroppe"  ; "Musselback Sculpin"    ; "Interface\\Icons\\INV_Misc_Fish_62" } ;
	{ "Fangzahnhering"              ; "Fangtooth Herring"     ; "Interface\\Icons\\INV_Misc_Fish_67" } ;
	{ "Nesselfisch"                 ; "Nettlefish"            ; "Interface\\Icons\\INV_Misc_Fish_72" } ; 
};

local koederID = 2;

local koeder = {
	{ "Nachtkriecher"                 ; "Night Crawlers"             ; "Interface\\Icons\\INV_Misc_MonsterTail_03" } ;
	{ "Helle Schmuckst\195\188cke"    ; "Bright Baubles"             ; "Interface\\Icons\\INV_Misc_Gem_Variety_02" } ;
	{ "Aquadynamischer Fischanlocker" ; "Aquadynamic Fish Attractor" ; "Interface\\Icons\\INV_Misc_Food_26" } ;
	{ "Gesch\195\164rfter Angelhaken" ; "Sharpened Fish Hook"        ; "Interface\\Icons\\INV_Misc_Hook_01" } ;
	{ "GL\195\188hw\195\188rmchen"    ; "Glow Worm"                  ; "Interface\\Icons\\inv_inscription_pigment_bug07" } 
};

-------------------------------------------------------------------------------
RatherBeFishin = {};

function RatherBeFishin.SlashCommand(command)

 if command == "reset" then
   RatherBeFishin_MainFrame:SetPoint("LEFT", 0, 0);

 elseif command == "hide" then
   RatherBeFishin_MainFrame:Hide();

 elseif command == "show" then
   RatherBeFishin_MainFrame:Show();

 end

end 

SlashCmdList["RatherBeFishin_Slash_Command"] = RatherBeFishin.SlashCommand;
SLASH_RatherBeFishin_Slash_Command1 = "/rbf";

-------------------------------------------------------------------------------
function RatherBeFishin_OnUpdate()
 local count;

 count = GetItemCount(koeder[koederID][localCode]);
 buts[2]:SetText(count);

 skillName, header, isExpanded, skillRank, numTempPoints, skillModifier, 
 skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType, 
 skillDescription = GetSkillLineInfo(fishingSkill);
 buts[3]:SetText(skillRank);

 count = GetItemCount(fische[1][localCode]);
 buts[7]:SetText(count);

 count = GetItemCount(fische[2][localCode]);
 buts[8]:SetText(count);

 count = GetItemCount(fische[3][localCode]);
 buts[9]:SetText(count);
end

-------------------------------------------------------------------------------
function SetLocaleStrings()
 local i, icon;

 if GetLocale() == "deDE" then
   localCode = 1;
   fishing = fishingDE;
   cooking = cookingDE;
 else
   localCode = 2;
   fishing = fishingEN;
   cooking = cookingEN;
 end

end
-------------------------------------------------------------------------------
function CheckSkills()
 local numSkills = GetNumSkillLines();
 local numProf = 1;

 prof = {};

 for i = 1, numSkills do
  skillName, header, isExpanded, skillRank, numTempPoints, skillModifier, 
  skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType, 
  skillDescription = GetSkillLineInfo(i);

  if skillName == fishing then
    fishingSkill = i;
  elseif isAbandonable == 1 then

    if skillName == "Kr\195\164uterkunde" then
     prof[numProf] = "Kr\195\164utersuche";
    else
     prof[numProf] = skillName;
    end

    numProf = numProf + 1;
  end
 end

cookingTex = GetSpellTexture(cooking);
proxTex1 = GetSpellTexture(prof[1]);
proxTex2 = GetSpellTexture(prof[2]);

--DEFAULT_CHAT_FRAME:AddMessage(cooking);
--DEFAULT_CHAT_FRAME:AddMessage(prof[1]);
--DEFAULT_CHAT_FRAME:AddMessage(prof[2]);

buts[4]:SetNormalTexture(GetSpellTexture(cooking));
buts[5]:SetNormalTexture(GetSpellTexture(prof[1]));
buts[6]:SetNormalTexture(GetSpellTexture(prof[2]));
buts[5]:SetAttribute("spell", prof[1]);
buts[6]:SetAttribute("spell", prof[2]);

end

-------------------------------------------------------------------------------
function RatherBeFishin_OnButton(self, button, down)

end
-------------------------------------------------------------------------------
function UpdateMainhand()
 mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
 myFishingRod, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
 itemEquipLoc, itemTexture = GetItemInfo(mainHandLink); 

 buts[2]:SetAttribute("type", "item");
 buts[2]:SetAttribute("item", koeder[koederID][localCode]);
 buts[2]:SetAttribute("target-item", myFishingRod);

end

-------------------------------------------------------------------------------
function RatherBeFishin_OnEvent()

 UpdateMainhand();

end

-------------------------------------------------------------------------------
function RatherBeFishin_OnDragStart()
 RatherBeFishin_MainFrame.StartMoving();
end
-------------------------------------------------------------------------------
function RatherBeFishin_OnMouseDown(self, button, down)

  if (button == "RightButton") then
   if (self == buts[2]) then
     koederID = koederID+1;
     if koederID == 6 then
       koederID = 1;
     end
     buts[2]:SetNormalTexture(koeder[koederID][3]);
     buts[2]:SetAttribute("item", koeder[koederID][localCode]);
   end
  
   RatherBeFishin_MainFrame:StartMoving();

  else
    if (self == buts[1]) then
      OpenAllBags();
    end
  end

end
-------------------------------------------------------------------------------
function RatherBeFishin_OnMouseUp(self, button, down)
 RatherBeFishin_MainFrame:StopMovingOrSizing();
end
-------------------------------------------------------------------------------
function RatherBeFishin_OnLoad(self)
 local x, y;

 RatherBeFishin_MainFrame:Raise();
 RatherBeFishin_MainFrame:RegisterForDrag("RightButton");
 RatherBeFishin_MainFrame:SetMovable();
 RatherBeFishin_MainFrame:RegisterEvent("UNIT_INVENTORY_CHANGED");

 SetLocaleStrings();

 buts = {};

 for i = 0, 8 do
  x = i % 3;
  y = math.floor(i / 3);

  buts[i+1] = CreateFrame("Button", nil, RatherBeFishin_MainFrame, "SecureActionButtonTemplate");
  buts[i+1]:SetWidth(iconSize);
  buts[i+1]:SetHeight(iconSize);
  buts[i+1]:SetNormalFontObject("GameFontHighlight");
  buts[i+1]:SetScript("OnMouseDown", RatherBeFishin_OnMouseDown);
  buts[i+1]:SetScript("OnMouseUp",  RatherBeFishin_OnMouseUp);
  buts[i+1]:SetPoint("LEFT", x*iconSize, y*iconSize);
 end

buts[1]:SetNormalTexture("Interface\\Icons\\INV_Misc_Bag_26_Spellfire");
buts[2]:SetNormalTexture(koeder[koederID][3]);
buts[3]:SetNormalTexture("Interface\\Icons\\Trade_Fishing");

buts[4]:SetNormalTexture("Interface\\Icons\\INV_Misc_Food_15");

buts[7]:SetNormalTexture(fische[1][3]);
buts[8]:SetNormalTexture(fische[2][3]);
buts[9]:SetNormalTexture(fische[3][3]);

buts[3]:SetAttribute("type", "spell");
buts[3]:SetAttribute("spell", fishing);

buts[4]:SetAttribute("type", "spell");
buts[4]:SetAttribute("spell", cooking);

buts[5]:SetAttribute("type", "spell");
buts[6]:SetAttribute("type", "spell");

UpdateMainhand();
CheckSkills();

end
